<?php
/**
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2024-01-18
 * Time: 17:02
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}
if (!isset($_G['cache']['plugin'])) {
    loadcache('plugin');
}

function threadUrl($tid)
{
    global $_G;
    return sprintf('%sforum.php?mod=viewthread&tid=%d', $_G['siteurl'], $tid);
}


function threadEditUrl($tid)
{
    global $_G;
    $post = C::t('forum_post')->fetch_threadpost_by_tid_invisible($tid);
    $pid = $post['pid'];
    return sprintf('%sforum.php?mod=post&action=edit&fid=%d&tid=%d&pid=%d&page=1', $_G['siteurl'], $post['fid'], $tid, $pid);
}

function covertCharsetForSite($str)
{
    global $_G;
    return strtoupper($_G['charset']) == 'UTF-8' ? $str : diconv($str, 'UTF-8', $_G['charset']);
}

function isAdmin()
{
    global $_G;
    $isAdmin = false;
    if (!empty($_G['uid']) && !empty($_G['group']['radminid']) && in_array($_G['group']['radminid'], array(1, 2, 3))) {
        $isAdmin = true;
    }
    return $isAdmin;
}

function hideTagText()
{
    $hide_text = covertCharsetForSite('已隐藏');
    $hide_text = sprintf('&nbsp;<strong>[%s]</strong>', $hide_text);
    return $hide_text;
}

function hideContentText($str)
{
    $hide_text = sprintf('<span style="color:#BBBBBB;">%s</span>', $str);
    return $hide_text;
}

function getThreadStatusText($status)
{
    $text = '未知';
    if ($status >= 0) {
        $text = '正常';
    } elseif ($status == -1) {
        $text = '回收站';
    } elseif ($status == -2) {
        $text = '待审';
    } elseif ($status == -3) {
        $text = '不通过';
    }
    return covertCharsetForSite($text);
}

