<?php
/**
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2024-01-18
 * Time: 13:53
 */

define('IDENTIFIER', 'qfthreadhide');

require_once libfile('function/common', 'plugin/qfthreadhide');

class plugin_qfthreadhide
{
    public $config;

    public static $identifier = 'qfthreadhide';

    public function __construct()
    {
        global $_G;
        if (!isset($_G['cache']['plugin'])) {
            loadcache('plugin');
        }
        if (!$_G['cache']['plugin']['qfthreadhide']) {
            return;
        }
        $this->config = $_G['cache']['plugin']['qfthreadhide'];
    }

    public function discuzcode($param)
    {
        global $_G;
        if (isset($_G['thread']['tid']) && $param['caller'] == 'discuzcode') {
            if (isset($param['param']) && is_array($param['param'])) {
                $isThread = end($param['param']); // 帖子内容
                if ($isThread) {
                    $isAuthor = false;
                    $authorid = (int)$_G['thread']['authorid'];
                    $isAdmin = isAdmin();
                    if (!empty($_G['uid']) && $_G['uid'] == $authorid) {
                        $isAuthor = true;
                    }
                    $isHide = C::t('#' . IDENTIFIER . '#qianfan_threadhide')->is_hide($_G['tid']);
                    if (!$isAuthor && !$isAdmin && $isHide) {
                        $hide_text = hideContentText($this->config['tips']);
                        $_G['discuzcodemessage'] = $hide_text;
                    }
                }
            }
        }
    }
}

class plugin_qfthreadhide_forum extends plugin_qfthreadhide
{
    public function post_top_output()
    {
        global $_G;
        $limitFids = isset($this->config['forums']) ? (array)unserialize($this->config['forums']) : array();
        $isAdmin = false;
        if (!empty($_G['uid']) && !empty($_G['group']['radminid']) && in_array($_G['group']['radminid'], array(1, 2, 3))) {
            $isAdmin = true;
        }
        if ($isAdmin && in_array($_G['fid'], $limitFids)) {
            $isHide = C::t('#' . IDENTIFIER . '#qianfan_threadhide')->is_hide($_G['tid']);
            include template(IDENTIFIER . ':post');
            return $qfthreadhide_return;
        }
        return;
    }

    public function post_qianfan_message($params)
    {
        global $_G;
        $message_array = array('post_newthread_succeed', 'post_newthread_mod_succeed', 'post_edit_succeed');
        if (isset($params['param'][0]) && in_array($params['param'][0], $message_array) && isset($params['param'][2]['tid'])) {
            $tid = $params['param'][2]['tid'];
            if (isset($_POST['qfthreadhide_select']) && $_POST['qfthreadhide_select'] == 'yes') {
                C::t('#' . IDENTIFIER . '#qianfan_threadhide')->insert_one($tid);
            } elseif (isset($_POST['qfthreadhide_select']) && $_POST['qfthreadhide_select'] == 'no') {
                C::t('#' . IDENTIFIER . '#qianfan_threadhide')->delete_one($tid);
            }
        }
        return;
    }

    public function forumdisplay_modlayer_output()
    {
        global $_G;
        $limitFids = isset($this->config['forums']) ? (array)unserialize($this->config['forums']) : array();
        if (in_array($_G['fid'], $limitFids)) {
            include template(IDENTIFIER . ':modlayer');
            return $qfthreadhide_return;
        }
    }

    // 帖子列表标记
    public function forumdisplay_thread_subject_output()
    {
        global $_G;
        $res = array();
        $tidArr = array();
        foreach ($_G['forum_threadlist'] as $key => $value) {
            $tidArr[] = $value['tid'];
        }
        $isAdmin = isAdmin();
        if ($tidArr && $isAdmin) {
            $hide_text = hideTagText();
            $exist = C::t('#' . IDENTIFIER . '#qianfan_threadhide')->query_ids($tidArr);
            foreach ($_G['forum_threadlist'] as $key => $value) {
                if (in_array($value['tid'], $exist)) {
                    $res[] = $hide_text;
                } else {
                    $res[] = '';
                }
            }
        }
        return $res;
    }

    // 帖子详情标记
    public function viewthread_title_extra()
    {
        global $_G;
        $isAdmin = isAdmin();
        if ($isAdmin) {
            $is_hide = C::t('#' . IDENTIFIER . '#qianfan_threadhide')->is_hide($_G['tid']);
            if ($is_hide) {
                $hide_text = hideTagText();
                return $hide_text;
            }
        }
        return '';
    }

    // 处理帖子附件
    function viewthread_bottom_output()
    {
        global $_G;
        if (isset($_G['thread']['tid'])) {
            $isAuthor = false;
            $authorid = (int)$_G['thread']['authorid'];
            $isAdmin = isAdmin();
            if (!empty($_G['uid']) && $_G['uid'] == $authorid) {
                $isAuthor = true;
            }
            $isHide = C::t('#' . IDENTIFIER . '#qianfan_threadhide')->is_hide($_G['tid']);
            if (!$isAuthor && !$isAdmin && $isHide) {
                include template(self::$identifier . ':js');
                return $return;
            }
        }
    }


}