<?php
/**
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2024-01-18
 * Time: 14:29
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class table_qianfan_threadhide extends discuz_table
{
    public function __construct()
    {
        $this->_table = 'qianfan_threadhide';
        $this->_pk = 'id';

        parent::__construct();
    }

    public function insert_one($tid)
    {
        if (!is_numeric($tid)) {
            return false;
        }
        $exist = DB::fetch_all('SELECT tid from %t WHERE tid=%d', array($this->_table, $tid));
        if (!$exist) {
            $insert = array();
            $insert['tid'] = $tid;
            $insert['created_at'] = time();
            DB::insert($this->_table, $insert, true);
        }
        return true;
    }

    public function batch_insert($tidArr)
    {
        if (!is_array($tidArr)) {
            return false;
        }
        $exist = array();
        $existArr = DB::fetch_all('SELECT tid from %t WHERE tid in (%n)', array($this->_table, $tidArr));
        foreach ($existArr as $t) {
            $exist[] = $t['tid'];
        }

        foreach ($tidArr as $tid) {
            if (!in_array($tid, $exist)) {
                $insert = array();
                $insert['tid'] = $tid;
                $insert['created_at'] = time();
                DB::insert($this->_table, $insert, true);
            }
        }
        return true;
    }

    public function query_ids($tidArr)
    {
        if (!is_array($tidArr)) {
            return false;
        }
        $exist = array();
        $existArr = DB::fetch_all('SELECT tid from %t WHERE tid in (%n)', array($this->_table, $tidArr));
        foreach ($existArr as $t) {
            $exist[] = $t['tid'];
        }
        return $exist;
    }

    public function delete_one($tid)
    {
        if (!is_numeric($tid)) {
            return false;
        }
        $exist = DB::fetch_all('SELECT tid from %t WHERE tid=%d', array($this->_table, $tid));
        if ($exist) {
            DB::delete($this->_table, DB::field('tid', $tid));
        }
        return true;
    }

    public function batch_delete($tidArr)
    {
        if (!is_array($tidArr)) {
            return false;
        }
        DB::delete($this->_table, DB::field('tid', $tidArr));
        return true;
    }

    public function is_hide($tid)
    {
        return (bool)DB::fetch_all('SELECT tid from %t WHERE tid=%d', array($this->_table, $tid));
    }

    public function format($list)
    {
        require_once libfile('function/common', 'plugin/qfthreadhide');
        $data = array();
        $tidArr = array();
        foreach ($list as $v) {
            $tidArr[] = $v['tid'];
        }
        $fidArr = array();
        if ($tidArr) {
            $threads = C::t("forum_thread")->fetch_all_by_tid($tidArr);
            foreach ($threads as $t) {
                $fidArr[] = $t['fid'];
            }
            $fidArr = array_values(array_unique($fidArr));
            $forumInfo = DB::fetch_all("SELECT fid,name FROM %t WHERE fid in (%n)", array("forum_forum", $fidArr), 'fid');
            $exist = C::t('#' . IDENTIFIER . '#qianfan_threadhide')->query_ids($tidArr);
            foreach ($tidArr as $tid) {
                $data[] = array(
                    'tid' => $tid,
                    'title' => $threads[$tid]['subject'],
                    'author' => empty($threads[$tid]['author']) ? lang('admincp', 'anonymous') : $threads[$tid]['author'],
                    'author_id' => $threads[$tid]['authorid'],
                    'postdate' => date('Y-m-d H:i:s', $threads[$tid]['dateline']),
                    'publishcolumn' => $forumInfo[$threads[$tid]['fid']]['name'],
                    'thread_url' => threadUrl($tid),
                    'thread_edit_url' => threadEditUrl($tid),
                    'is_hide' => in_array($tid, $exist) ? 1 : 0,
                    'status' => getThreadStatusText($threads[$tid]['displayorder']),
                );
            }
        }
        return $data;
    }

}